#include <iostream>
using namespace std;

float SearchForGpa(const int ids[], const float gpas[], int searchId);
void DisplayIdsInRange(const int ids[], const float gpas[], float startGpa,
	float endGpa);
void AddToGpa(float gpas[], const int ages[], int searchAge, float boost);
void DisplayAllValues(const int ids[], const float gpas[], const int ages[]);

// Global constant
const int NUM_OF_STUDENTS = 6;

void main()
{
	
	int id;
	int ids[] =    { 111, 234, 567, 880, 912, 222 };
	float gpas[] = { 3.1, 2.8, 4.0, 3.8, 2.5, 3.0 };
	int ages[] =   { 18,   19,  22,  20,  21,  22 };

	cout << "Enter ID: ";
	cin >> id;

	// SearchForGpa returns the gpa for the given id or -1 if id was not found
	float gpa = SearchForGpa(ids, gpas, id);
	if (gpa < 0)
	{
		cout << "ID not found.\n";
	}
	else
	{
		cout << "GPA is " << gpa << endl;
	}

	// Display all IDs that have gpa 2.0 - 3.0
	DisplayIdsInRange(ids, gpas, 2.0, 3.0);
	DisplayIdsInRange(ids, gpas, 1.0, 1.5);

	// Add the 4th parameter value to all GPAs with age 21
	AddToGpa(gpas, ages, 21, 0.1);

	DisplayAllValues(ids, gpas, ages);
}

void DisplayAllValues(const int ids[], const float gpas[], const int ages[])
{
	for (int i = 0; i < NUM_OF_STUDENTS; i++)
	{
		cout << ids[i] << "  " << gpas[i] << "  " << ages[i] << endl;
	}
}

void AddToGpa(float gpas[], const int ages[], int searchAge, float boost)
{
	for (int i = 0; i < NUM_OF_STUDENTS; i++)
	{
		if (ages[i] == searchAge)
		{
			gpas[i] += boost;
		}
	}
}

void DisplayIdsInRange(const int ids[], const float gpas[], float startGpa,
	float endGpa)
{
	bool gpaFound = false;

	cout << "IDs with GPA in range " << startGpa << " to " << endGpa << ":\n";
	for (int i = 0; i < NUM_OF_STUDENTS; i++)
	{
		if (gpas[i] >= startGpa && gpas[i] <= endGpa)
		{
			cout << ids[i] << endl;
			gpaFound = true;
		}
	}

	if (!gpaFound)
	{
		cout << "No GPAs in that range.\n";
	}
}

float SearchForGpa(const int ids[], const float gpas[], int searchId)
{
	float gpa = -1;

	for (int i = 0; i < NUM_OF_STUDENTS && gpa < 0; i++)
	{
		if (ids[i] == searchId)
		{
			gpa = gpas[i];
		}
	}

	return gpa;
}